<template>
  <div id="info" v-if="info">
    <div id="row" v-for="(item, index) in Object.keys(info)" :key="index">
      <div>{{ item }}</div>
      <div v-if="editable">
        <input type="text" :value="info[item]" :key="item" @change="onChangeValue">
      </div>
      <div v-else>{{ info[item] }}</div>
    </div>
  </div>
</template>

<script>
import axios from 'axios'

export default {
  props: ['item', 'name', 'editable'],
  data () {
    return {
      info: null
    }
  },
  watch: {
    item () {
      this.getInfo()
    },
    name () {
      this.getInfo()
    }
  },
  mounted () {
    this.getInfo()
  },
  methods: {
    getInfo () {
      let item, name
      if (this.item === undefined) {
        item = this.$route.params.item
      } else {
        item = this.item
      }
      if (this.name === undefined) {
        name = this.$route.params.name
      } else {
        name = this.name
      }
      axios
        .get('/api/' + item + '/' + name)
        .then((res) => {
          this.info = res.data
        })
    },
    onChangeValue (a) {
      console.log(a, a.target.value)
      let item, name
      if (this.item === undefined) {
        item = this.$route.params.item
      } else {
        item = this.item
      }
      if (this.name === undefined) {
        name = this.$route.params.name
      } else {
        name = this.name
      }
      axios.post('/api/' + item + '/' + name, this.info)
    }
  }
}
</script>

<style>
#info #row {
  display: grid;
  grid-template-columns: 20% 20%;
  padding: 1em;
  border-bottom: 1px solid;
}
#info #row > div:first-child {
  border-right: 1px solid;
}
#info #row > div:last-child {
  word-wrap: break-word;
}
</style>
